#include <windows.h>

#pragma comment (linker, "/entry:Entry")
#pragma comment (linker, "/subsystem:console")

#pragma comment (linker, "/merge:.rdata=.text")

#pragma comment (lib, "kernel32.lib")



typedef void const *PCVOID;



class Stream {

  HANDLE Handle;

  public:

  Stream (HANDLE const H) { Handle = H; }

  __forceinline void Write (PCVOID const Data, size_t Length) {

    DWORD Written;

    WriteFile (Handle, Data, Length, &Written, 0);

  }

};




class StdOut : public Stream {

  public:

  StdOut (void) : Stream (GetStdHandle (STD_OUTPUT_HANDLE)) { }

  __forceinline void Print (PCSTR const Message) {

    Write (Message, lstrlen (Message));

  }

};




extern "C" DWORD WINAPI Entry (void const * const Arg) {

  (void) (Arg);

  StdOut SO;

  SO.Print ("Hello, world!\n");

  return 0;

}
